// Generated by Apple Swift version 2.3 (swiftlang-800.10.12 clang-800.0.38)
#pragma clang diagnostic push

#if defined(__has_include) && __has_include(<swift/objc-prologue.h>)
# include <swift/objc-prologue.h>
#endif

#pragma clang diagnostic ignored "-Wauto-import"
#include <objc/NSObject.h>
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>

#if !defined(SWIFT_TYPEDEFS)
# define SWIFT_TYPEDEFS 1
# if defined(__has_include) && __has_include(<uchar.h>)
#  include <uchar.h>
# elif !defined(__cplusplus) || __cplusplus < 201103L
typedef uint_least16_t char16_t;
typedef uint_least32_t char32_t;
# endif
typedef float swift_float2  __attribute__((__ext_vector_type__(2)));
typedef float swift_float3  __attribute__((__ext_vector_type__(3)));
typedef float swift_float4  __attribute__((__ext_vector_type__(4)));
typedef double swift_double2  __attribute__((__ext_vector_type__(2)));
typedef double swift_double3  __attribute__((__ext_vector_type__(3)));
typedef double swift_double4  __attribute__((__ext_vector_type__(4)));
typedef int swift_int2  __attribute__((__ext_vector_type__(2)));
typedef int swift_int3  __attribute__((__ext_vector_type__(3)));
typedef int swift_int4  __attribute__((__ext_vector_type__(4)));
#endif

#if !defined(SWIFT_PASTE)
# define SWIFT_PASTE_HELPER(x, y) x##y
# define SWIFT_PASTE(x, y) SWIFT_PASTE_HELPER(x, y)
#endif
#if !defined(SWIFT_METATYPE)
# define SWIFT_METATYPE(X) Class
#endif

#if defined(__has_attribute) && __has_attribute(objc_runtime_name)
# define SWIFT_RUNTIME_NAME(X) __attribute__((objc_runtime_name(X)))
#else
# define SWIFT_RUNTIME_NAME(X)
#endif
#if defined(__has_attribute) && __has_attribute(swift_name)
# define SWIFT_COMPILE_NAME(X) __attribute__((swift_name(X)))
#else
# define SWIFT_COMPILE_NAME(X)
#endif
#if !defined(SWIFT_CLASS_EXTRA)
# define SWIFT_CLASS_EXTRA
#endif
#if !defined(SWIFT_PROTOCOL_EXTRA)
# define SWIFT_PROTOCOL_EXTRA
#endif
#if !defined(SWIFT_ENUM_EXTRA)
# define SWIFT_ENUM_EXTRA
#endif
#if !defined(SWIFT_CLASS)
# if defined(__has_attribute) && __has_attribute(objc_subclassing_restricted)
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# else
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# endif
#endif

#if !defined(SWIFT_PROTOCOL)
# define SWIFT_PROTOCOL(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
# define SWIFT_PROTOCOL_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
#endif

#if !defined(SWIFT_EXTENSION)
# define SWIFT_EXTENSION(M) SWIFT_PASTE(M##_Swift_, __LINE__)
#endif

#if !defined(OBJC_DESIGNATED_INITIALIZER)
# if defined(__has_attribute) && __has_attribute(objc_designated_initializer)
#  define OBJC_DESIGNATED_INITIALIZER __attribute__((objc_designated_initializer))
# else
#  define OBJC_DESIGNATED_INITIALIZER
# endif
#endif
#if !defined(SWIFT_ENUM)
# define SWIFT_ENUM(_type, _name) enum _name : _type _name; enum SWIFT_ENUM_EXTRA _name : _type
# if defined(__has_feature) && __has_feature(generalized_swift_name)
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME) enum _name : _type _name SWIFT_COMPILE_NAME(SWIFT_NAME); enum SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_ENUM_EXTRA _name : _type
# else
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME) SWIFT_ENUM(_type, _name)
# endif
#endif
#if defined(__has_feature) && __has_feature(modules)
@import UIKit;
@import AmpCore;
@import GoogleInteractiveMediaAds;
@import Foundation;
#endif

#pragma clang diagnostic ignored "-Wproperty-attribute-mismatch"
#pragma clang diagnostic ignored "-Wduplicate-method-arg"
@class UIView;
@class AmpPlayer;
@class NSCoder;
@protocol IMAEventObserver;
@class NSNotification;
@class IMAAdsLoader;
@class IMAAdsLoadedData;
@class IMAAdLoadingErrorData;
@class IMAAdsManager;
@class IMAAdEvent;
@class IMAAdError;


/// Class in charge of managing the integration between the AMP SDK and the IMA SDK
SWIFT_CLASS("_TtC6AmpIMA13AmpIMAManager")
@interface AmpIMAManager : UIViewController <PlayerEventObserver, IMAAdsLoaderDelegate, IMAAdsManagerDelegate>

/// The view used by the player, ads will be shown here as well.
@property (nonatomic, readonly, strong) UIView * _Nonnull videoView;

/// The amp player associated with a specific IMA Manager.
@property (nonatomic, readonly, strong) AmpPlayer * _Nonnull ampPlayer;

/// The current state of the video playback.
@property (nonatomic) enum PlaybackState playbackState;

/// The current buferring state.
@property (nonatomic) enum BufferingState bufferingState;

/// Initializes a new AmpIMAManager with the parameters provided.
///
/// \param ampPlayer The amp player associated with a specific IMA Manager.
///
/// \param videoView The view used by the player, ads will be shown here as well.
///
/// \returns  A configured instance of an AmpIMAManager.
- (nonnull instancetype)initWithAmpPlayer:(AmpPlayer * _Nonnull)ampPlayer videoView:(UIView * _Nonnull)videoView :(NSCoder * _Nullable)coder OBJC_DESIGNATED_INITIALIZER;
- (nonnull instancetype)initWithCoder:(NSCoder * _Nonnull)coder;

/// Registers an observer to be notified of player events.
///
/// \param observer The observer to be registered.
///
/// \returns  The id of the registered observer.
- (void)registerObserver:(id <IMAEventObserver> _Nonnull)observer;

/// Removes a registered observer.
///
/// \param id The id of the observer to be removed.
- (void)removeObserver:(id <IMAEventObserver> _Nonnull)observer id:(NSInteger)id;

/// Resumes the current ad if any.
- (void)resume;

/// Pause the current ad if any.
- (void)pause;

/// :nodoc:
- (void)contentDidFinishPlaying:(NSNotification * _Nonnull)notification;

/// Request ads.
///
/// \param adsUrl The ads to be requested.
///
/// \param companionView The view where companions should be shown. Default: nil.
- (void)requestAdsWithAdsUrl:(NSString * _Nonnull)adsUrl companionView:(UIView * _Nullable)companionView;

/// :nodoc:
- (void)adsLoader:(IMAAdsLoader * _Null_unspecified)loader adsLoadedWithData:(IMAAdsLoadedData * _Null_unspecified)adsLoadedData;

/// :nodoc:
- (void)adsLoader:(IMAAdsLoader * _Null_unspecified)loader failedWithErrorData:(IMAAdLoadingErrorData * _Null_unspecified)adErrorData;

/// :nodoc:
- (void)adsManager:(IMAAdsManager * _Null_unspecified)adsManager didReceiveAdEvent:(IMAAdEvent * _Null_unspecified)event;

/// :nodoc:
- (void)adsManager:(IMAAdsManager * _Null_unspecified)adsManager didReceiveAdError:(IMAAdError * _Null_unspecified)error;

/// :nodoc:
- (void)adsManagerDidRequestContentPause:(IMAAdsManager * _Null_unspecified)adsManager;

/// :nodoc:
- (void)adsManagerDidRequestContentResume:(IMAAdsManager * _Null_unspecified)adsManager;

/// :nodoc:
- (void)adsManager:(IMAAdsManager * _Null_unspecified)adsManager adDidProgressToTime:(NSTimeInterval)mediaTime totalTime:(NSTimeInterval)totalTime;

/// :nodoc:
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;

/// :nodoc:
- (void)onHandledResignActive:(AmpPlayer * _Nonnull)ampPlayer;

/// :nodoc:
- (void)onHandledDidBecomeActive:(AmpPlayer * _Nonnull)ampPlayer;

/// Stops the entire module.
- (void)stop;
@end

@class NSError;


/// Protocol used to receive IMA events.
SWIFT_PROTOCOL("_TtP6AmpIMA16IMAEventObserver_")
@protocol IMAEventObserver
@optional

/// Callback called when the playback state of the manager changes.
///
/// \param imaManager The instance of the AMP IMA Manager that sends the event.
- (void)onIMAPlaybackStateChanged:(AmpIMAManager * _Nonnull)imaManager;

/// Callback called when the buffering state of the manager changes.
///
/// \param imaManager The instance of the AMP IMA Manager that sends the event.
- (void)onIMABufferingStateChanged:(AmpIMAManager * _Nonnull)imaManager;

/// Callback called when the position of the manager changes.
///
/// \param imaManager The instance of the AMP IMA Manager that sends the event.
- (void)onIMAPositionChange:(AmpIMAManager * _Nonnull)imaManager;

/// Callback called when an ad starts.
///
/// \param imaManager The instance of the AMP IMA Manager that sends the event.
- (void)onIMAAdStarted:(AmpIMAManager * _Nonnull)imaManager;

/// Callback called when an ad ends.
///
/// \param imaManager The instance of the AMP IMA Manager that sends the event.
- (void)onIMAAdEnded:(AmpIMAManager * _Nonnull)imaManager;

/// Callback called when an ad is requested.
///
/// \param imaManager The instance of the AMP IMA Manager that sends the event.
- (void)onIMAAdsRequested:(AmpIMAManager * _Nonnull)imaManager;

/// Callback called when ad view is tapped.
///
/// \param imaManager The instance of the AMP IMA Manager that sends the event.
- (void)onIMATap:(AmpIMAManager * _Nonnull)imaManager;

/// Callback called when the ima manager experiences an error.
///
/// \param imaManager The instance of the AMP IMA Manager that sends the event.
///
/// \param error The error sent.
- (void)onIMAError:(AmpIMAManager * _Nonnull)imaManager error:(NSError * _Nonnull)error;
@end

#pragma clang diagnostic pop
